aboutsummaryrefslogtreecommitdiff
path: root/bin
diff options
context:
space:
mode:
authorTom Ryder <tom@sanctum.geek.nz>2016-09-20 13:35:22 +1200
committerTom Ryder <tom@sanctum.geek.nz>2016-09-20 13:35:22 +1200
commit267bcc9dc9ed7f59430d811da472a6da29c7e5e2 (patch)
tree0217ac12ae1e291f53b3ba8419675cbb581a08ee /bin
parentAllow aliases, just don't use them (diff)
downloaddotfiles-267bcc9dc9ed7f59430d811da472a6da29c7e5e2.tar.gz
dotfiles-267bcc9dc9ed7f59430d811da472a6da29c7e5e2.zip
Add mex(1df)
Diffstat (limited to 'bin')
-rwxr-xr-xbin/mex53
1 files changed, 53 insertions, 0 deletions
diff --git a/bin/mex b/bin/mex
new file mode 100755
index 00000000..005149d8
--- /dev/null
+++ b/bin/mex
@@ -0,0 +1,53 @@
+#!/bin/sh
+# Make the first non-executable instance of files with the given names in $PATH
+# executable
+self=mex
+
+# Check we have at least one argument
+if [ "$#" -eq 0 ] ; then
+ printf >&2 '%s: At least one name required\n' "$self"
+ exit 2
+fi
+
+# Iterate through the given names
+for name ; do
+
+ # Clear the found variable
+ found=
+
+ # Start iterating through $PATH, with colon prefix/suffix to correctly
+ # handle the fenceposts
+ path=:$PATH:
+ while [ -n "$path" ] ; do
+
+ # Pop the first directory off $path into $dir
+ dir=${path%%:*}
+ path=${path#*:}
+
+ # Check $dir is non-null
+ [ -n "$dir" ] || continue
+
+ # If a file with the needed name exists in the directory and isn't
+ # executable, we've found our candidate and can stop iterating
+ if [ -f "$dir"/"$name" ] && ! [ -x "$dir"/"$name" ] ; then
+ found=$dir/$name
+ break
+ fi
+ done
+
+ # If the "found" variable was defined to something, we'll try to change its
+ # permissions
+ if [ -n "$found" ] ; then
+ chmod +x -- "$found" || ex=1
+
+ # If not, we'll report that we couldn't find it, and flag an error for the
+ # exit status
+ else
+ printf >&2 '%s: No non-executable name "%s" in PATH\n' "$self" "$name"
+ ex=1
+ fi
+done
+
+# We exit 1 if any of the names weren't found or if changing their permissions
+# failed
+exit "${ex:-0}"